/*****************************************************************************
 * Copyright (c) 2022, BoLian Technologies Inc.
 *
 * All rights reserved.
 * ****************************************************************************
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * - Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the disclaimer below.
 *
 * BoLian' name may not be used to endorse or promote products derived from
 * this software without specific prior written permission.
 *
 * DISCLAIMER: THIS SOFTWARE IS PROVIDED BY NATIONS "AS IS" AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT ARE
 * DISCLAIMED. IN NO EVENT SHALL NATIONS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * ****************************************************************************/

/**
 * @file bms_app.c
 * @author BoLian
 * @version v1.0.0
 *
 * @copyright Copyright (c) 2022, BoLian Technologies Inc. All rights reserved.
 */

#include <string.h>
#include <stdint.h>
#include "bms_app.h"
#include "bms_init.h"
#include "gpio.h"


void Process_100ms_CYC(void)
{
}

void Process_500ms_CYC1(void){
    gpio_toggle(LED_PORT,LED_PIN);
}

void Process_500ms_CYC2(void)
{

}


void Process_1000ms_CYC(void)
{    

}

void app_init(void)
{
}
uint32_t g_u32_20msCnt=0;
uint8_t  g_u8_20msCntOverFlag=0;

uint32_t  Cyc1000msCount= 0;
uint32_t  Cyc100msCount= 0;
uint32_t  Cyc20msCount= 0;
uint8_t cyc2Flag=0;
void bms_app(void){
    bms_init();

    //printf("\r\nSystem hardware initialization is completed!\r\n");
    
    app_init();
    
    for(;;)  //main loop
    {
        //20ѭʱ20msıg_u32_20msCnt
        if(Cyc20msCount != g_u32_20msCnt)  
        {
            Cyc20msCount = g_u32_20msCnt;
            
            //100msѭ
            if(0 == Cyc20msCount%5)
            {
                Process_100ms_CYC();
                Cyc100msCount++;
            }
            
            //500msѭ
            if(Cyc100msCount==4&&cyc2Flag==0){
               Process_500ms_CYC2();
               cyc2Flag=1;
            }else if(Cyc100msCount==5){
               Process_500ms_CYC1();
               Cyc100msCount = 0;
               cyc2Flag=0;
            }
                
            //1000msѭ
            if(Cyc1000msCount != Cyc20msCount/50)
            {
                Process_1000ms_CYC();
                Cyc1000msCount = Cyc20msCount/50;   
            }
        }else
        {
            
        }
    }
}
