/*****************************************************************************
 * Copyright (c) 2022, BoLian Technologies Inc.
 *
 * All rights reserved.
 * ****************************************************************************
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * - Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the disclaimer below.
 *
 * BoLian' name may not be used to endorse or promote products derived from
 * this software without specific prior written permission.
 *
 * DISCLAIMER: THIS SOFTWARE IS PROVIDED BY NATIONS "AS IS" AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT ARE
 * DISCLAIMED. IN NO EVENT SHALL NATIONS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * ****************************************************************************/

/**
 * @file PeripheralControl.c
 * @author BoLian
 * @version v1.0.0
 *
 * @copyright Copyright (c) 2022, BoLian Technologies Inc. All rights reserved.
 */

#include "PeripheralControl.h"
#include "gpio.h"

void PeripheralControl_init(void){
    Insulation_init();
    vpro_init();
    bt_en_init();
    rs485_en_init();
    AFE_Mode_init();
    AFE_Mode_high();
}


/* EEP̿ */
void vpro_init(void){
    gpio_init(VPRO_EN_PORT,VPRO_EN_PIN);
}
void vpro_enable(void){
    gpio_high(VPRO_EN_PORT,VPRO_EN_PIN);
}
void vpro_disable(void){
    gpio_low(VPRO_EN_PORT,VPRO_EN_PIN);
}

/* ʹ */
void bt_en_init(void){
    gpio_init(BT_EN_PORT,BT_EN_PIN);
}
void bt_enable(void){
    gpio_high(BT_EN_PORT,BT_EN_PIN);
}
void bt_disable(void){
    gpio_low(BT_EN_PORT,BT_EN_PIN);
}

/* 485ʹ */
void rs485_en_init(void){
    gpio_init(RS485_PORT,RS485_EN_PIN);
}
void rs485_enable(void){
    gpio_high(RS485_PORT,RS485_EN_PIN);
}
void rs485_disable(void){
    gpio_low(RS485_PORT,RS485_EN_PIN);
}

//δ
/* Ե MOSFET */
void Insulation_init(void){
    gpio_init(MOS_CTL_PORT,MOS_CTL_PIN);
}
void Insulation_high(void){
    gpio_high(MOS_CTL_PORT,MOS_CTL_PIN);
}
void Insulation_low(void){
    gpio_low(MOS_CTL_PORT,MOS_CTL_PIN);
}

/* SH367309AFE_MODE */
void AFE_Mode_init(void){
    gpio_init(AFE_MODE_PORT,GPIO_PIN_8);
}
void AFE_Mode_high(void){
    gpio_high(AFE_MODE_PORT,GPIO_PIN_8);
}
void AFE_Mode_low(void){
    gpio_low(AFE_MODE_PORT,GPIO_PIN_8);
}






