/*****************************************************************************
 * Copyright (c) 2022, BoLian Technologies Inc.
 *
 * All rights reserved.
 * ****************************************************************************
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * - Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the disclaimer below.
 *
 * BoLian' name may not be used to endorse or promote products derived from
 * this software without specific prior written permission.
 *
 * DISCLAIMER: THIS SOFTWARE IS PROVIDED BY NATIONS "AS IS" AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT ARE
 * DISCLAIMED. IN NO EVENT SHALL NATIONS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * ****************************************************************************/

/**
 * @file def.h
 * @author BoLian
 * @version v1.0.0
 *
 * @copyright Copyright (c) 2022, BoLian Technologies Inc. All rights reserved.
 */
#ifndef __DEF_H__
#define __DEF_H__

#ifdef __cplusplus
extern "C" {
#endif
#include "n32g45x.h"
/* BMSӲ˿ں궨 */

/* 4G */
#define G4_PORT         GPIOA
#define G4_TX_PIN       GPIO_PIN_2
#define G4_RX_PIN       GPIO_PIN_3
/* ʹ */
#define BT_EN_PORT      GPIOA
#define BT_EN_PIN       GPIO_PIN_6

/* ڻѡ */
#define M1_PORT         GPIOA
#define M1_TX_PIN       GPIO_PIN_9
#define M1_RX_PIN       GPIO_PIN_10

/* RS485 */
#define RS485_PORT      GPIOC
#define RS485_TX_PIN    GPIO_PIN_10
#define RS485_RX_PIN    GPIO_PIN_11
#define RS485_EN_PIN    GPIO_PIN_12

/* CAN */
#define BCAN1_PORT      GPIOA
#define BCAN1_RX        GPIO_PIN_11
#define BCAN1_TX        GPIO_PIN_12
/* AFEʹ */
#define VPRO_EN_PORT    GPIOC
#define VPRO_EN_PIN     GPIO_PIN_9
/* AFEͨѶ */
#define AFE_IIC_PORT    GPIOB
#define AFE_SCL_PIN     GPIO_PIN_6
#define AFE_SDA_PIN     GPIO_PIN_7
/* MOSFET */
#define MOS_CTL_PORT    GPIOA
#define MOS_CTL_PIN     GPIO_PIN_7
/* AFEģʽѡ  */
#define AFE_MODE_PORT   GPIOB
#define AFE_MODE_PIN    GPIO_PIN_8 

/* 
  رע⣬ʹPB3PB4PA15IOʱҪȽJTAGӿڣSWDӿ
  GPIO_ConfigPinRemap(GPIO_RMP_SW_JTAG_SW_ENABLE, ENABLE);
*/

/* N32ٷLED壬ֻڲԣɺɾ */
#define TEST_LED1_PORT  GPIOA
#define TEST_LED1_PIN   GPIO_PIN_8

#define TEST_LED2_PORT  GPIOB
#define TEST_LED2_PIN   GPIO_PIN_4

#define TEST_LED3_PORT  GPIOB
#define TEST_LED3_PIN   GPIO_PIN_5

typedef enum
{
    FAILED = 0,
    PASSED = !FAILED
} Status;

#define TO_STR(s) #s
#define COMB(str1,str2) str1##str2
//int UART0= 115200;
//printf("UART0=%d\n", COMB(UART, 0));//ַϲΪUART0
//printf("%s\n", TO_STR(3.14));//ֱַ

#endif
